/***************************************************************************
 *            copy_file.c
 *
 *  Fri Oct 24 11:26:25 2003
 *  Copyright  2003  Phil Kett
 *  pkett@genesis-midi.com
 ****************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "../include/remsync.h"
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>



int
copy_file (char *src, char *dest)
{
	int inF, outF;
	char line[1024000];
	int bytes, failed = 0;

	if ((inF = open (src, O_RDONLY)) == -1)
	{
		if (conf.debug) printf ("Src: %s\n", src);
		syslog(LOG_ERR,"copy_file: open Src %s Failed",src);
		failed = 1;
	}
	if ((outF =
	     open (dest, O_WRONLY | O_CREAT | O_TRUNC,
		   S_IRWXU | S_IRWXG | S_IRWXO)) == -1)
	{
		if (conf.debug) {
			printf ("Dest: %s\n", dest);
			syslog(LOG_ERR,"copy_file:open Dest %s failed",dest);
		}
		failed = 1;
	}
	if (conf.debug) printf ("Copying %s to %s\n", src, dest);
	if (failed != 1)
	{
		while ((bytes = read (inF, line, sizeof (line))) > 0)
			write (outF, line, bytes);
	}
	else
	{
		syslog(LOG_ERR,"Copy_file: Failed\n");
	}

	close (inF);
	close (outF);

	return 0;

}
